import 'dart:developer';

import 'package:marianum_mobile/api/apiResponse.dart';
import 'package:marianum_mobile/api/marianumcloud/webdav/queries/listFiles/listFilesCache.dart';
import 'package:marianum_mobile/api/marianumcloud/webdav/queries/listFiles/listFilesResponse.dart';
import 'package:marianum_mobile/data/dataHolder.dart';

class FilesProps extends DataHolder {
  String _path = "/";

  ListFilesResponse? _listFilesResponse;
  ListFilesResponse get listFilesResponse => _listFilesResponse!;

  @override
  List<ApiResponse?> properties() {
    return [_listFilesResponse];
  }

  @override
  void run() {
    notifyListeners();
    ListFilesCache(
      path: _path,
      onUpdate: (ListFilesResponse data) => {
        log("Got cache response"),
        _listFilesResponse = data,
        notifyListeners(),
      }
    );
  }

  void setPath(String path) {
    _listFilesResponse = null;
    _path = path;
    run();
  }

}